C*****************************************
       program ang_to_3D
C*****************************************
       implicit none
	
	   real vox(11,500000)
	   real e1, e2, temp, hex, slice
	   real x_max, y_max, step, pi
	   real x_i, y_j, dist, dist_test
	   real x_dim, y_dim, tmp
	   real temp1, temp2, temp3
	   real x_ii, y_jj
	   real d1,d2,d3,d4,d5,d6,d7,d10
	   integer i, j, nnline, grid, ii
	   integer index, header, bomb
	   integer file_n, first, last, msf, lsf
	   integer k, itmp, hex_row, x_clipped, x_clip
	   integer yjf,yjl,d8,d9,d11
	   integer x_step, y_step, xxx, yyy, zzz
	   integer out_type1, out_type2, out_type3
	   integer r(25000)
	   character*1 one
	   character*1 two
	   character*7 keyword
	   character*80 tempword

       write(6,*) '=============================================='
	   write(6,*) ' PROGRAM TAKES DATA FROM .ANG FILES, RESAMPLES '
	   write(6,*) ' IT FROM A HEX TO SQUARE GRID, WRITES A NEW '
	   write(6,*) ' SET OF .ANG FILES ON A SQUARE GRID, AND THEN '
	   write(6,*) ' PREPARES FILES THAT CAN BE USED WITH PARAVIEW '	   
       write(6,*) ' (COLOR BY GRAIN ID) OR AS INPUT TO PH_TO_VTK '
       write(6,*) ' (COLOR BY GRAIN ORIENTATION) '
	   write(6,*)
	   write(6,*) ' DEVELOPED BY CMU MRSEC'
	   write(6,*) '  version 04/20/09'
       write(6,*) '=============================================='
	    
		! compiled with gfortran ang_to_3D.f -o ang_to_3D  
		pi=4.0*atan(1.0) 
		hex=sin(60*pi/180)
		itmp=1
		temp1 = -1.0
		temp2 = -1.0
		temp3 =  0.0
		bomb=0
		  d1=3.14159
		  d2=1.57080
		  d3=1.57080
		  d4=0.00000
		  d5=0.00000
		  d6=-1.0
		  d7=-1.000
		  d8 = -1
		  d9 = -1
		  d10 = 0.00
		  d11 = 2
	   x_clip=10
	   	
       open(21, file='input.txt', status='old')
       read(21,*) keyword
	   read(21,*) header
       read(21,*) first
	   read(21,*) last
	   read(21,*) step, slice 
	   read(21,*) out_type1, out_type2, out_type3
       close(21)
 
c this part opens numbered files from 001-099
   
 44    format(f10.5,f10.5,f10.5,f12.5,f13.5,f7.1,f7.3,f3.0,f7.0,
     &   f7.3,f7.0)
 45    format(f10.5,f10.5,f10.5,f12.5,f13.5,f7.1,f7.3,I3,I7,f7.3,I7)
 46    format(A)

c this part opens numbered files from 001-099
       do file_n=first,last

	   if (file_n.eq.0) then
	    one=char(48)
		write(6,46)'00'//one//'_'//keyword//'_ID.ang'
		open (32, file='00'//one//'_'//keyword//'_ID.ang'
     &         ,status='unknown')
		goto 1008
	   endif
	   
	   if (file_n.gt.0.and.file_n.lt.10) then
	    one=char(48+file_n)
		open (32, file='00'//one//'_'//keyword//'_ID.ang'
     &         ,status='unknown')
	    goto 1008
	   endif	
		
	   if (file_n.gt.9.and.file_n.lt.100) then
	    msf=int(file_n/10)
		lsf=file_n-(10*msf)
		one=char(48+msf)
		two=char(48+lsf)
		open (32, file='0'//one//two//'_'//keyword//'_ID.ang'
     &         ,status='unknown')
	    goto 1008
	   endif
 
 1008     continue	 
       

c  This part is to determines the total number of lines in the data file

		nnline = 0

 1010     continue
		read(32,*,end=1011)
		nnline=nnline+1
		goto 1010
 1011     continue
        close(32)

        write (6,*) nnline

c  Open the files
	   if (file_n.eq.0) then
	    one=char(48)
		open (32, file='00'//one//'_'//keyword//'_ID.ang'
     &         ,status='unknown')
		open (33, file='sq_'//keyword//'_00'//one//'.ang'
     &         ,status='unknown')
		goto 1018
	   endif
	   
	   if (file_n.gt.0.and.file_n.lt.10) then
	    one=char(48+file_n)
		open (32, file='00'//one//'_'//keyword//'_ID.ang'
     &         ,status='unknown')
		open (33, file='sq_'//keyword//'_00'//one//'.ang'
     &         ,status='unknown')	
	    goto 1018
	   endif	
		
	   if (file_n.gt.9.and.file_n.lt.100) then
	    msf=int(file_n/10)
		lsf=file_n-(10*msf)
		one=char(48+msf)
		two=char(48+lsf)
		open (32,file='0'//one//two//'_'//keyword//'_ID.ang'
     &         ,status='unknown')
		open (33, file='sq_'//keyword//'_0'//one//two//'.ang'
     &         ,status='unknown')	 
	    goto 1018
	   endif
	    
 1018     continue	 

c this step reads all of the data into a matrix  

        write(6,*)'file:',file_n
		
		if(file_n.eq.first) then
		 x_max=0
		 y_max=0
		 do i=1,nnline
		  read(32,44) vox(1,i),vox(2,i),vox(3,i),vox(4,i),
     &   vox(5,i),vox(6,i),vox(7,i),vox(8,i),
     &	 vox(9,i),vox(10,i),vox(11,i)
	     
		  if (i.lt.5) then
		   write(6,45) vox(1,i),vox(2,i),vox(3,i),vox(4,i),
     &   vox(5,i),vox(6,i),vox(7,i),int(vox(8,i)),
     &	 int(vox(9,i)),vox(10,i), int(vox(11,i))
		  endif
	 	 
	      if(vox(4,i).GT.x_max) x_max=vox(4,i)   !find x and y max
	      if(vox(5,i).GT.y_max) y_max=vox(5,i)
	
		 enddo
		 close(32)

		 write(6,*) 'x max      y max'        !write out important parameters
		 write(6,*) x_max, y_max
		 write(6,*) 'step:', step
		 write(6,*) 'grid: square'
		 xxx = int(x_max/step)+1-x_clip !set x_clip at top of file
		 yyy = int(y_max/step)+1
		 zzz = last-first+1
		 
		else
		
		 do i=1,nnline
		  read(32,44) vox(1,i),vox(2,i),vox(3,i),vox(4,i),
     &   vox(5,i),vox(6,i),vox(7,i),vox(8,i),
     &	 vox(9,i),vox(10,i),vox(11,i)
		 enddo
		 close(32)
        endif

c        The next step is to write out all of the data

		  x_step=int(x_max/step)  !on the new square grid, this is the number of voxels
		  x_clipped=x_step-x_clip  ! clip the edge
		  y_step=int(y_max/step)
		  write(6,*) x_clipped, y_step

		  do j=0,y_step   
		    do i=0,x_clipped  !x_step for no clipping
			
			hex_row=int(j/0.866)     ! this determine the target index, i, in 
		    index=i+(x_step*hex_row) ! vox to find the corresponding voxel
            
		    x_i=float(i)*step
		    y_j=float(j)*step
		    ii=0
		    dist_test=100

			yjf=int(index-(5*x_step)) ! this determines the limits of our seach which
			yjl=int(index+(5*x_step)) ! is conducted five rows before and after the target
			
			if (yjf.lt.1) then        ! there are no negative indices
			 yjf=1
			endif 
		 
		     do k=yjf,yjl             ! this finds the minumum distance between the 
		     dist=((((x_i-vox(4,k))**2)+((y_j-vox(5,k))**2))**0.5)  ! current voxel
		     if(dist.LT.dist_test) then   ! on the square grid and the nearest 
		      dist_test=dist              ! voxel in the search range
		      ii=k 
		     endif
            enddo
		  
			x_dim=float(i)*step
		    y_dim=float(j)*step
		  
		    if(dist_test.gt.(3*step)) then      !If the smallest distance is more
			 write(6,*) dist_test, i, j         !than 3 steps away, then a warning
			 bomb=bomb+1                        !is written and a place holder is 
			 if (bomb.gt.10) then               !put in the .ang file.  If this 
              write(6,*)'too many errors, quit' !happens 10 times, it quits.
 			  goto 9020                       
			 endif  
			 write(33,45)d1,d2,d3,x_dim,y_dim,d6,d7,d8,d9,d10,d11	
			 goto 2000
			endif

		   if(ii.lt.1) then                     !warns of index errors
		     write(6,*)'index error'                  
		     write(33,45)d1,d2,d3,x_dim,y_dim,d6,d7,d8,d9,d10,d11
		     goto 2000
		   endif  
		  
		   write(33,45)vox(1,ii),vox(2,ii),vox(3,ii),x_dim,
     &     y_dim,vox(6,ii),vox(7,ii),int(vox(8,ii)),
     &	   int(vox(9,ii)),vox(10,ii), int(vox(11,ii))
 2000      continue
		  enddo
		 enddo
	     close(33) 
		 enddo






 		open (44, file='random.txt', status='unknown')
		do i=1,25000	
		 read(44,*) r(i)
		enddo
		close(44)

        if (out_type1.eq.1) then
		 open (34, file='vtk_id.vti', status='unknown')
		 write(34,46)'<?xml version="1.0"?>'
		 write(34,46)' <VTKFile type="ImageData" version="0.1" byte_order
     &="LittleEndian">'
		 write(34,*)'  <ImageData WholeExtent="0',xxx,'0',yyy,'0',zzz,
     &'"   Origin="0 0 0" Spacing="1 1 1">'
 		 write(34,*)'    <Piece Extent="0',xxx,'0',yyy,'0',zzz,'">'
		 write(34,46)'       <CellData Scalars="ID">'
		 write(34,46)'         <DataArray Name="ID" type="Int32" 
     &format="ascii">' 
		endif
		 
        if (out_type2.eq.1) then
		 open (35, file='vtk_phase.vti', status='unknown')
		 write(35,46)'<?xml version="1.0"?>'
		 write(35,46)' <VTKFile type="ImageData" version="0.1" byte_order
     &="LittleEndian">'
		 write(35,*)'  <ImageData WholeExtent="0',xxx,'0',yyy,'0',zzz,
     &'"   Origin="0 0 0" Spacing="1 1 1">'
 		 write(35,*)'    <Piece Extent="0',xxx,'0',yyy,'0',zzz,'">'
		 write(35,46)'       <CellData Scalars="ID">'
		 write(35,46)'         <DataArray Name="ID" type="Int32" 
     &format="ascii">'
		endif

        if (out_type3.eq.1) then		 
		open (36, file='vtk_id.ph', status='unknown')
		write(36,'(3I5)') xxx,yyy,zzz
		endif 


	 



       do file_n=first,last
	
	   
	   write(6,*) 'file;',file_n

	   if (file_n.eq.0) then
	    one=char(48)
		open (32, file='sq_'//keyword//'_00'//one//'.ang'
     &         ,status='unknown')
		goto 3008
	   endif
	   
	   if (file_n.gt.0.and.file_n.lt.10) then
	    one=char(48+file_n)
		open (32, file='sq_'//keyword//'_00'//one//'.ang'
     &         ,status='unknown')
	    goto 3008
	   endif	
		
	   if (file_n.gt.9.and.file_n.lt.100) then
	    msf=int(file_n/10)
		lsf=file_n-(10*msf)
		one=char(48+msf)
		two=char(48+lsf)
		open (32, file='sq_'//keyword//'_0'//one//two//'.ang'
     &         ,status='unknown')
	    goto 3008
	   endif
 
 3008     continue	 
       

c  This part is to determines the total number of line (lines in the data file)

		nnline = 0

 3010     continue

		read(32,*,end=3011)
		nnline=nnline+1
		goto 3010

 3011     continue
 
        close(32)

       
       write(6,*) 'number of lines in file',nnline


	   if (file_n.eq.0) then
	    one=char(48)
		open (32, file='sq_'//keyword//'_00'//one//'.ang'
     &         ,status='unknown')

		goto 3018
	   endif
	   
	   if (file_n.gt.0.and.file_n.lt.10) then
	    one=char(48+file_n)
		open (32, file='sq_'//keyword//'_00'//one//'.ang'
     &         ,status='unknown')

	    goto 3018
	   endif	
		
	   if (file_n.gt.9.and.file_n.lt.100) then
	    msf=int(file_n/10)
		lsf=file_n-(10*msf)
		one=char(48+msf)
		two=char(48+lsf)
		open (32, file='sq_'//keyword//'_0'//one//two//'.ang'
     &         ,status='unknown')
	    goto 3018
	   endif
	    
 3018     continue	 


! read and write data

		do i=1,nnline	 
		 read(32,44) vox(1,i),vox(2,i),vox(3,i),vox(4,i),
     &   vox(5,i),vox(6,i),vox(7,i),vox(8,i),
     &	 vox(9,i),vox(10,i),vox(11,i)
	    enddo
		close (32)
		
        if (out_type3.eq.1) then
		  do index=1,nnline
		   write(36,'(I6)') int(vox(11,index))
		  enddo
        endif
		
		
        if (out_type1.eq.1) then		
		  do index=1,nnline
		    if(int(vox(11,index)).eq.1) then
		     write(34,*) int(vox(11,index))
		    endif	
			if(int(vox(11,index)).eq.2) then
		     write(34,*) int(vox(11,index))
		    endif		 
		    if(int(vox(11,index)).ne.1.and.int(vox(11,index)).ne.2) then
		     write(34,*) r(int(vox(11,index)))
		    endif 
		  enddo
		endif  

        if (out_type2.eq.1) then
		  do index=1,nnline
		    if(int(vox(11,index)).eq.1) then
		     write(35,*) int(vox(8,index))
		    endif	
		    if(int(vox(11,index)).eq.2) then
		     write(35,*) int(vox(8,index))
		    endif		 
		    if(int(vox(11,index)).ne.1.and.int(vox(11,index)).ne.2) then
		     write(35,*) int(vox(8,index))
		    endif 
		  enddo
        endif


 3025     continue		

		 enddo

        if (out_type1.eq.1) then
         write(34,*)'        </DataArray>'
         write(34,*)'      </CellData>'
         write(34,*)'    </Piece>'
         write(34,*)'  </ImageData>'
         write(34,*)'</VTKFile>'
	     close(34) 
		endif

        if (out_type2.eq.1) then		
         write(35,*)'        </DataArray>'
         write(35,*)'      </CellData>'
         write(35,*)'    </Piece>'
         write(35,*)'  </ImageData>'
         write(35,*)'</VTKFile>'
	     close(35) 
        endif
		
        if (out_type3.eq.1) then
		 close(36)
        endif
		
 9020    continue
  
         end