C*****************************************
       program grainID
C*****************************************
       implicit none
	   include 'common.fi'
	   

       write(6,*) '=============================================='
	   write(6,*) ' THIS PROGRAM ASSIGNS GRAIN ID NUMBERS TO THE  '
	   write(6,*) ' GRAINS IN A STACK OF PARALLEL EBSD MAPS AND '
	   write(6,*) ' WRITES A LIST CONTAINING THE GRAIN NUMBER, ITS '	   
	   write(6,*) ' EULER ANGLES, AND THE TOTAL NUMBER OF VOXELS.  '	    	    
	   write(6,*) ' THE INPUTs ARE A SET OF PARALLEL .ANG FILES  '
	   write(6,*) ' THE OUTPUT IS ANOTHER SET, WITH GRAIN IDs IN COL11  ' 
	   write(6,*)
	   write(6,*) ' DEEVELOPED BY CMU MRSEC'
	   write(6,*) '  version 04/17/2009'
       write(6,*) '=============================================='
	   
       pi = 4.0*atan(1.0)
	   
c      this reads the information in the input file 	   
       open(21, file='input.txt', status='old')
       read(21,*) keyword
       read(21,*) slice
       read(21,*) first
	   read(21,*) last
	   read(21,*) header
	   read(21,*) msym
       close(21)	   

       call get_symop (msym, O, nsymm)

c      this is just a check to make sure that the file
c      numbers are within the allowed bounds
       if(first.gt.98.or.last.gt.99) then
	    write(6,*) 'first and/or last exceed limits'
		goto 9000
	   endif	

c       I reserve grain 1 and grain 2 to be the special cases of
c       euler angles 0,0,0 and pi, pi/2, pi/2
		grain=0
		grain_p=0
		grain_p=grain_p+1
		grain=grain+1
		grains1(1,1)=0.0
		grains1(2,1)=0.0	
		grains1(3,1)=0.0	
		grains1(4,1)=1.0
		grains1(5,1)=0.0
		grains1(6,1)=0.0
		grains1(7,1)=0.0
		grains1(8,1)=1.0
		grains1(9,1)=1.0		
		
		grain=grain+1
		grain_p=grain_p+1
		grains1(1,2)=3.14159
		grains1(2,2)=1.57080	
		grains1(3,2)=1.57080	
		grains1(4,2)=2.0	
		grains1(5,2)=0.0
		grains1(6,2)=0.0
		grains1(7,2)=0.0
		grains1(8,2)=1.0
		grains1(9,2)=1.0			   
	   write(6,'(A)')'Developing grain ID list'

c      this long mess of conditionals picks the appropriate
c      names for the sequential input files. The files must have names of the 
c      type: NNN_keyword.ang, where keyword is a seven character string and NNN is
c      a number between 000 and 099. If the file name is not seven characters,
c      redimension keyword in the common and recompile

       do file_n=first,last

	   if (file_n.eq.0) then
	    one=char(48)
		open (32, file='00'//one//'_'//keyword//'.ang'
     &         ,status='unknown')
		goto 8
	   endif
	   
	   if (file_n.gt.0.and.file_n.lt.9) then
	    one=char(48+file_n)
		open (32, file='00'//one//'_'//keyword//'.ang'
     &         ,status='unknown')
	    goto 8
	   endif		   
	   
	   if (file_n.eq.9) then
	    one=char(48+file_n)
		open (32, file='00'//one//'_'//keyword//'.ang'
     &         ,status='unknown')
	    goto 8
	   endif	   
	   
	   if (file_n.gt.9.and.file_n.lt.99) then
	    msf=int(file_n/10)
		lsf=file_n-(10*msf)
		one=char(48+msf)
		two=char(48+lsf)
		open (32, file='0'//one//two//'_'//keyword//'.ang'
     &         ,status='unknown')	 
	    goto 8
	   endif
	   
 8     continue	 

c  This part is to determines the total number of lines in the data file

		nnline_1 = 0
 10     continue
		read(32,*,end=11)
		nnline_1=nnline_1+1
		goto 10
 11     continue
        close(32)
 12    	format(A,I7,A,I2)
        n_1=nnline_1
		write(6,12) 'There are',n_1,' data points in file ',file_n
		
c      this long mess of conditionals picks (again) the appropriate
c      names for the sequential files.	Also open the output file.	

	   if (file_n.eq.0) then
	    one=char(48)
		open (32, file='00'//one//'_'//keyword//'.ang'
     &         ,status='unknown')	
		open (33, file='00'//one//'_'//keyword//'_ID.ang'
     &         ,status='unknown')
		goto 28
	   endif
	   
	   if (file_n.gt.0.and.file_n.lt.9) then
	    one=char(48+file_n)
		open (32, file='00'//one//'_'//keyword//'.ang'
     &         ,status='unknown')
		open (33, file='00'//one//'_'//keyword//'_ID.ang'
     &         ,status='unknown')
	    goto 28
	   endif		   
	   
	   if (file_n.eq.9) then
	    one=char(48+file_n)
		open (32, file='00'//one//'_'//keyword//'.ang'
     &         ,status='unknown')
		open (33, file='00'//one//'_'//keyword//'_ID.ang'
     &         ,status='unknown')
	    goto 28
	   endif	   
	   
	   if (file_n.gt.9.and.file_n.lt.99) then
	    msf=int(file_n/10)
		lsf=file_n-(10*msf)
		one=char(48+msf)
		two=char(48+lsf)
		open (32, file='0'//one//two//'_'//keyword//'.ang'
     &         ,status='unknown')
		open (33, file='0'//one//two//'_'//keyword//'_ID.ang'
     &         ,status='unknown')
	    goto 28
	   endif
	   
 28     continue	 

c       here, all the pixel data is read into a matrix
c       If there are more than 500000 pixels, then
c       the dimensions of the matrix layer will have to be increased.

 29      format(f9.5,2f10.5,2f13.5,f7.1,f7.3,f3.0,f7.0,f7.3,I7)
 30      format(f9.5,2f10.5,2f13.5,f7.1,f7.3,f3.0,f7.0,f7.3)			
 31      format(f9.5,2f10.5,2f13.5,f7.1,f7.3,I3,I7,f7.3,I7)         
		 
		 
!       add header tolerance	 
		 
		 do head=1,header  !read the header
		  read(32,*) tempword
		 enddo		

         do i=1,n_1-header
		 read(32,30)vox(1,i),vox(2,i),vox(3,i),vox(4,i),
     &   vox(5,i),vox(6,i),vox(7,i),vox(8,i),
     &	 vox(9,i),vox(10,i)
	     vox(11,i)=0.0   ! this is the grain ID (temporary)
		 enddo
		
	     close(32)
		
        do i=1,n_1-header
		
c        if the pixel already has a grain ID, leave it alone
         if (vox(11,i).ne.0.0) then
		  goto 35
		 endif 
		 
c        Check each line against all of the grains already in the list		 
         do j=1,grain
c         if the Euler angles of this pixel matches one on the list, give it this ID
		  if(grains1(1,j).eq.vox(1,i).and.grains1(2,j).eq.vox(2,i)
     &    .and.grains1(3,j).eq.vox(3,i)) then
		   vox(11,i)=float(j)
		   goto 35
		  endif
		enddo  ! end of the loop over grains 

c       if not, give it the next number in the list and add it to the list.
        grain=grain+1
		grain_p=grain_p+1
		vox(11,i)=float(grain)
		grains1(1,grain)=vox(1,i)
		grains1(2,grain)=vox(2,i)	
		grains1(3,grain)=vox(3,i)	
		grains1(4,grain)=vox(11,i)
		grains1(9,grain)=float(file_n)
		
 35		continue
 
		enddo  !  end of the loop over voxels (i)
		
		write(6,'(A,I5,A)') 'A total of ', grain,' grains have been located'
		
c       determine average positions        		
		do i=3,grain
		 if (grains1(9,i).ne.file_n) then
		  goto 40
		 endif 
		 counter=0
		 xsum=0.0
		 ysum=0.0
		 do j=1,n_1-header
		  if(grains1(1,i).eq.vox(1,j).and.grains1(2,i).eq.vox(2,j)
     &     .and.grains1(3,i).eq.vox(3,j)) then
		   counter=counter+1
		   xsum=xsum+vox(4,j)
		   ysum=ysum+vox(5,j)
		  endif
		 enddo  ! this is j loop
		 
		 grains1(5,i)=xsum/float(counter)
		 grains1(6,i)=ysum/float(counter)
		 grains1(7,i)=-(file_n*slice)
		 grains1(8,i)=float(counter)
 40      continue		 
        enddo

        enddo                 ! This is the end of the file_n looop
		
	
		  write(6,'(A)') 'now I have to identify and group different
     &     pieces of the same grain: this takes awhile'		
		
		
c         next, check to see if it close and already assigned grain ID 
        count=0
		 
        do i=1,grain
		 do j=i+3,grain
	
		 ! If they were already assigned the same grain ID, skip the disorientation calculation	 	 
		 if (grains1(4,i).eq.grains1(4,j)) then
		  goto 45
		 endif 

		 ! If it has already been changed, don't check it again	 
		 if (grains1(4,j).lt.j) then
		  goto 45
		 endif 
		 
		 e1(1)=grains1(1,i)  !These Euler angles must be in radians
	     e1(2)=grains1(2,i)
	     e1(3)=grains1(3,i)
	     e2(1)=grains1(1,j)
	     e2(2)=grains1(2,j)
	     e2(3)=grains1(3,j)
		 
		  call EToG(e1,g1)
		  call EToG(e2,g2)
           disor2 = pi/2
           do i_s=1,nsymm	
		    call symop(O,i_s,so1)
		    call MToM (so1,g1,gg1)
			do j_s=1,nsymm
		     call symop(O,j_s,so2)
		     call MToM(so2,g2,gg2)
		     call trans(gg2,gt)
		     call MToM(gg1,gt,dg)
			   misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1)/2)
			    if (misor.lt.0.035) then  ! This is a 2 degree criterion
		          grains1(4,j)=grains1(4,i)
			      ! I should probably put a distance criterion in here
				  count=count+1
			      goto 45
			   endif
		  call trans (gg1, gt)		   
		  call MToM (gg2, gt, dg)
               misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1)/2)
			    if (misor.lt.0.035) then   ! This is a 2 degree criterion
		          grains1(4,j)=grains1(4,i)
			      ! I should probably put a distance criterion in here
				  count=count+1
			      goto 45
			   endif
		   enddo
		  enddo



 45      continue		 
		 
		 enddo
		enddo

        write(6,'(A,I10,A)') 'found', count,' related pairs'	
			
		
		write(6,'(A)')'reassign the unique grain IDs to the .ang files'
		
       do file_n=first,last

	   if (file_n.eq.0) then
	    one=char(48)
		open (32, file='00'//one//'_'//keyword//'.ang'
     &         ,status='unknown')
		goto 108
	   endif
	   
	   if (file_n.gt.0.and.file_n.lt.9) then
	    one=char(48+file_n)
		open (32, file='00'//one//'_'//keyword//'.ang'
     &         ,status='unknown')
	    goto 108
	   endif		   
	   
	   if (file_n.eq.9) then
	    one=char(48+file_n)
		open (32, file='00'//one//'_'//keyword//'.ang'
     &         ,status='unknown')
	    goto 108
	   endif	   
	   
	   if (file_n.gt.9.and.file_n.lt.99) then
	    msf=int(file_n/10)
		lsf=file_n-(10*msf)
		one=char(48+msf)
		two=char(48+lsf)
		open (32, file='0'//one//two//'_'//keyword//'.ang'
     &         ,status='unknown')	 
	    goto 108
	   endif
	   
 108     continue	 

	     
c  This part is to determines the total number of lines in the data file

		nnline_1 = 0
 110     continue
		read(32,*,end=111)
		nnline_1=nnline_1+1
		goto 110
 111     continue
        close(32)
 112    format(A,I7,A,I2)
        n_1=nnline_1
		write(6,112) 'There are',n_1,' data points in file ',file_n
		
c      this long mess of conditionals picks (again) the appropriate
c      names for the sequential files.	Also open the output file.	

	   if (file_n.eq.0) then
	    one=char(48)
		open (32, file='00'//one//'_'//keyword//'.ang'
     &         ,status='unknown')	
		open (33, file='00'//one//'_'//keyword//'_ID.ang'
     &         ,status='unknown')
		goto 128
	   endif
	   
	   if (file_n.gt.0.and.file_n.lt.9) then
	    one=char(48+file_n)
		open (32, file='00'//one//'_'//keyword//'.ang'
     &         ,status='unknown')
		open (33, file='00'//one//'_'//keyword//'_ID.ang'
     &         ,status='unknown')
	    goto 128
	   endif		   
	   
	   if (file_n.eq.9) then
	    one=char(48+file_n)
		open (32, file='00'//one//'_'//keyword//'.ang'
     &         ,status='unknown')
		open (33, file='00'//one//'_'//keyword//'_ID.ang'
     &         ,status='unknown')
	    goto 128
	   endif	   
	   
	   if (file_n.gt.9.and.file_n.lt.99) then
	    msf=int(file_n/10)
		lsf=file_n-(10*msf)
		one=char(48+msf)
		two=char(48+lsf)
		open (32, file='0'//one//two//'_'//keyword//'.ang'
     &         ,status='unknown')
		open (33, file='0'//one//two//'_'//keyword//'_ID.ang'
     &         ,status='unknown')
	    goto 128
	   endif
	   
 128     continue	 

c       here, all the pixel data is read into a matrix
c       If there are more than 500000 pixels, then
c       the dimensions of the matrix layer will have to be increased.

		 
!       add header tolerance	 
		 
		  do head=1,header  !read the header
		    read(32,*) tempword
		  enddo		

         do i=1,n_1-header
		 read(32,30)vox(1,i),vox(2,i),vox(3,i),vox(4,i),
     &   vox(5,i),vox(6,i),vox(7,i),vox(8,i),
     &	 vox(9,i),vox(10,i)
	     vox(11,i)=0.0   ! this is the grain ID (temporary)
		 enddo
	     close(32)
		
		
        do i=1,n_1-header
         do j=1,grain

c         when the Euler angles of this pixel matches one on the list, give it this ID
		 
		  if(grains1(1,j).eq.vox(1,i).and.grains1(2,j).eq.vox(2,i)
     &    .and.grains1(3,j).eq.vox(3,i)) then
		   vox(11,i)=grains1(4,j)
		   goto 135
		  endif
		  
		 enddo  ! end of the loop over grains 
		 write(6,'(A)')'no match'
		
 135		continue
 
		enddo  !  end of the loop over voxels

	
	    do i=1,n_1-header
		 write(33,31)vox(1,i),vox(2,i),vox(3,i),vox(4,i),
     &   vox(5,i),vox(6,i),vox(7,i),int(vox(8,i)),
     &	 int(vox(9,i)),vox(10,i), int(vox(11,i))
		enddo
		close(33)	

        enddo                 ! This is the end of the file_n looop
		
		
	        write(6,'(A)') 'now I am refining the grain list'	

		
c       now, refine the grain list		
		g_max=0.0
		do i=1,grain
		 if(grains1(4,i).gt.g_max) then
		  g_max=grains1(4,i)
		 endif 
		enddo
        write(6,*)g_max
       
		
		do i=1,int(g_max)
		 do j=1,grain
		  if(int(grains1(4,j)).eq.i) then
		    grains(5,i)=grains(5,i)+grains1(8,j)
		  endif
		 enddo
		enddo 
		
       do i=1,int(g_max)
		 grains(1,i)=i
		 do j=1,grain
		  if(int(grains1(4,j)).eq.i) then
		    grains(2,i)=grains1(1,j)
			grains(3,i)=grains1(2,j)
			grains(4,i)=grains1(3,j)
		  endif
		 enddo
		enddo 		
		
c       write out a file with the grain information
        count=0
		open (34, file=keyword//'_grains.txt',status='unknown')	
		do i=1,int(g_max)
		if (grains(5,i).ne.0.0) then
		 count=count+1
		 write(34,*)grains(1,i),grains(2,i),grains(3,i),
     &        grains(4,i), grains(5,i)
		endif
		enddo
		write(6,'(A,I10,A)') 'grain list has', count,' unique grains'
		close(34)
		
 1050   format(I7,3f10.3)	
c       the file written here is needed to run ph_to_vtk 	
		open (35, file='grains.txt',status='unknown')	
		do i=1,int(g_max)
		if (grains(5,i).ne.0.0) then
		 write(35,1050)int(grains(1,i)),grains(2,i),
     &     grains(3,i),grains(4,i)
	    else
		 write(35,1050)int(grains(1,i)),0.0,0.0,0.0
		endif
		enddo
		close(35)		
		
 9000    continue
        end